Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision d26fb7625dde5c4fa08b01ff2fa421d45b545931)
+++ src/UIElements/Makefile.am	(revision 3690e473417f286de3e772d934f7ae47120b763c)
@@ -280,8 +280,10 @@
 	libMolecuilderFragmentation.la \
 	libMolecuilderJobs.la
+	
 if CONDJOBMARKET
 libMolecuilderUI_la_LIBADD += \
 	${JobMarket_Controller_LIBS}
 endif
+
 libMolecuilderUI_la_LIBADD += \
 	libMolecuilderFragmentationSummation.la \
@@ -351,13 +353,6 @@
 ## configuration header file is generated at configure time and should not be
 ## shipped with the source tarball.
-#libMolecuilderUI_libincludedir = $(libdir)/MoleCuilder/include
-#nodist_libMolecuilderUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
-
-## Install the generated pkg-config file (.pc) into the expected location for
-## architecture-dependent package configuration information.  Occasionally,
-## pkg-config files are also used for architecture-independent data packages,
-## in which case the correct install location would be $(datadir)/pkgconfig.
-#pkgconfigdir = $(libdir)/pkgconfig
-#pkgconfig_DATA = $(top_builddir)/MoleCuilder.pc
+libMolecuilderUI_libincludedir = $(libdir)/MoleCuilder/include
+nodist_libMolecuilderUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
 
 if CONDQTGUI
@@ -384,9 +379,34 @@
 
 nobase_libMolecuilderQtUI_la_include_HEADERS = ${QTUIHEADER} $(QTUIUI_UIFILES)
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
 libMolecuilderQtUI_la_SOURCES = ${QTUISOURCE}
 nodist_libMolecuilderQtUI_la_SOURCES =
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
 libMolecuilderQtUI_la_LDFLAGS += -version-info $(MOLECUILDER_SO_VERSION)
-#libMolecuilderQtUI_libincludedir = $(libdir)/MoleCuilder/include
-#nodist_libMolecuilderQtUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderQtUI_libincludedir = $(libdir)/MoleCuilder/include
+nodist_libMolecuilderQtUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
 
 BUILT_SOURCES += ui_dialoglight.h ui_changeposition.h
Index: src/UIElements/Views/Qt4/Plotting/Makefile.am
===================================================================
--- src/UIElements/Views/Qt4/Plotting/Makefile.am	(revision d26fb7625dde5c4fa08b01ff2fa421d45b545931)
+++ src/UIElements/Views/Qt4/Plotting/Makefile.am	(revision 3690e473417f286de3e772d934f7ae47120b763c)
@@ -44,12 +44,36 @@
 
 nobase_libMolecuilderQwtUI_la_include_HEADERS = ${QWTHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
 libMolecuilderQwtUI_la_SOURCES = ${QWTSOURCE}
 nodist_libMolecuilderQwtUI_la_SOURCES =
+nodist_libMolecuilderQwtUI_la_SOURCES += allqwtmocs.moc.cpp
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
 libMolecuilderQwtUI_la_LDFLAGS += -version-info $(MOLECUILDER_SO_VERSION)
-#libMolecuilderQwtUI_libincludedir = $(libdir)/MoleCuilder/include
-#nodist_libMolecuilderQwtUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
 
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderQwtUI_libincludedir = $(libdir)/MoleCuilder/include
+nodist_libMolecuilderQwtUI_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
 
-nodist_libMolecuilderQwtUI_la_SOURCES += allqwtmocs.moc.cpp
 
 #Rules needed for Qt4