Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -270,5 +270,5 @@
 
 CommandLineDialog::ElementCommandLineQuery::ElementCommandLineQuery(string title, string _description) :
-    Dialog::ElementQuery(title,target, _description)
+    Dialog::ElementQuery(title, _description)
 {}
 
@@ -285,5 +285,5 @@
       elemental = periode->FindElement(*ZRunner);
       ASSERT(elemental != NULL, "Invalid element specified in ElementCommandLineQuery");
-      elements.push_back(elemental);
+      tmp.push_back(elemental);
     }
     return true;
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/Dialog.cpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -105,5 +105,5 @@
 
 void Dialog::IntQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -117,5 +117,5 @@
 
 void Dialog::BooleanQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -129,5 +129,5 @@
 
 void Dialog::StringQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -141,5 +141,5 @@
 
 void Dialog::StringsQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -153,5 +153,5 @@
 
 void Dialog::DoubleQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -167,5 +167,5 @@
 
 void Dialog::AtomQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -180,5 +180,5 @@
 
 void Dialog::MoleculeQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -198,5 +198,5 @@
 
 void Dialog::VectorQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -215,5 +215,5 @@
 
 void Dialog::BoxQuery::setResult() {
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
 }
 
@@ -226,4 +226,4 @@
 
 void Dialog::ElementQuery::setResult(){
-  ValueStorage::getInstance().setCurrentValue(title, tmp);
-}
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/Dialog.hpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -189,5 +189,5 @@
     virtual void setResult();
   protected:
-    std::vector<element *> elements;
+    std::vector<element *> tmp;
   };
 
Index: src/UIElements/QT4/QTDialog.cpp
===================================================================
--- src/UIElements/QT4/QTDialog.cpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/QT4/QTDialog.cpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -85,15 +85,15 @@
 }
 
-void QTDialog::queryBoolean(char const*, bool*,string){
+void QTDialog::queryBoolean(char const*,string){
   // TODO
   ASSERT(false, "Not implemented yet");
 }
 
-void QTDialog::queryAtom(char const*, atom**, string){
+void QTDialog::queryAtom(char const*, string){
   // TODO
   ASSERT(false, "Not implemented yet");
 }
 
-void QTDialog::queryBox(char const*, Box*, string){
+void QTDialog::queryBox(char const*, string){
   // TODO
   ASSERT(false, "Not implemented yet");
@@ -101,40 +101,40 @@
 
 
-void QTDialog::queryInt(const char *title, int *target,string)
-{
-  registerQuery(new IntQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryDouble(const char* title, double* target,string){
-  registerQuery(new DoubleQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryString(const char* title, std::string *target,string)
-{
-  registerQuery(new StringQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryStrings(const char* title, std::vector<std::string> *target,string)
-{
-  registerQuery(new StringsQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryMolecule(const char *title,molecule **target,string)
-{
-  registerQuery(new MoleculeQTQuery(title,target,inputLayout,this));
-}
-
-void QTDialog::queryVector(const char* title, Vector *target, bool check,string) {
-  registerQuery(new VectorQTQuery(title,target,check,inputLayout,this));
-}
-
-void QTDialog::queryElement(const char* title, std::vector<element *> *target,string){
-  registerQuery(new ElementQTQuery(title,target,inputLayout,this));
+void QTDialog::queryInt(const char *title,string)
+{
+  registerQuery(new IntQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryDouble(const char* title,string){
+  registerQuery(new DoubleQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryString(const char* title,string)
+{
+  registerQuery(new StringQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryStrings(const char* title,string)
+{
+  registerQuery(new StringsQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryMolecule(const char *title,string)
+{
+  registerQuery(new MoleculeQTQuery(title,inputLayout,this));
+}
+
+void QTDialog::queryVector(const char* title, bool check,string) {
+  registerQuery(new VectorQTQuery(title,check,inputLayout,this));
+}
+
+void QTDialog::queryElement(const char* title, string){
+  registerQuery(new ElementQTQuery(title,inputLayout,this));
 }
 
 /************************** Query Objects *******************************/
 
-QTDialog::IntQTQuery::IntQTQuery(string _title,int *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::IntQuery(_title,_target),
+QTDialog::IntQTQuery::IntQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::IntQuery(_title),
     parent(_parent)
 {
@@ -163,6 +163,6 @@
 }
 
-QTDialog::DoubleQTQuery::DoubleQTQuery(string title,double *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::DoubleQuery(title,_target),
+QTDialog::DoubleQTQuery::DoubleQTQuery(string title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::DoubleQuery(title),
     parent(_parent)
 {
@@ -192,6 +192,6 @@
 
 
-QTDialog::StringQTQuery::StringQTQuery(string _title,string *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::StringQuery(_title,_target),
+QTDialog::StringQTQuery::StringQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::StringQuery(_title),
     parent(_parent)
 {
@@ -219,6 +219,6 @@
 }
 
-QTDialog::StringsQTQuery::StringsQTQuery(string _title,vector<string> *_target,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::StringsQuery(_title,_target),
+QTDialog::StringsQTQuery::StringsQTQuery(string _title,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::StringsQuery(_title),
     parent(_parent)
 {
@@ -257,6 +257,6 @@
 }
 
-QTDialog::MoleculeQTQuery::MoleculeQTQuery(string _title, molecule **_target, QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::MoleculeQuery(_title,_target),
+QTDialog::MoleculeQTQuery::MoleculeQTQuery(string _title, QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::MoleculeQuery(_title),
     parent(_parent)
 {
@@ -293,6 +293,6 @@
 }
 
-QTDialog::VectorQTQuery::VectorQTQuery(std::string title, Vector *_target, bool _check,QBoxLayout *_parent,QTDialog *_dialog) :
-    Dialog::VectorQuery(title,_target,_check),
+QTDialog::VectorQTQuery::VectorQTQuery(std::string title, bool _check,QBoxLayout *_parent,QTDialog *_dialog) :
+    Dialog::VectorQuery(title,_check),
     parent(_parent)
 {
@@ -329,6 +329,6 @@
 
 
-QTDialog::ElementQTQuery::ElementQTQuery(std::string _title, vector<element *> *_target, QBoxLayout *_parent, QTDialog *_dialog) :
-    Dialog::ElementQuery(_title,_target),
+QTDialog::ElementQTQuery::ElementQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog) :
+    Dialog::ElementQuery(_title),
     parent(_parent)
 {
@@ -349,5 +349,5 @@
   thisLayout->addWidget(inputBox);
 
-  pipe = new ElementQTQueryPipe(&elements,_dialog,inputBox);
+  pipe = new ElementQTQueryPipe(&tmp,_dialog,inputBox);
   pipe->update(inputBox->currentIndex());
   connect(inputBox,SIGNAL(currentIndexChanged(int)),pipe,SLOT(update(int)));
Index: src/UIElements/QT4/QTDialog.hpp
===================================================================
--- src/UIElements/QT4/QTDialog.hpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/QT4/QTDialog.hpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -36,14 +36,14 @@
 
   virtual void queryEmpty(const char*, std::string);
-  virtual void queryBoolean(const char *, bool *, std::string = "");
-  virtual void queryInt(const char *, int *,std::string = "");
-  virtual void queryDouble(const char*,double *,std::string = "");
-  virtual void queryString(const char*, std::string *,std::string = "");
-  virtual void queryStrings(const char*, std::vector<std::string> *,std::string = "");
-  virtual void queryAtom(const char*,atom**,std::string = "");
-  virtual void queryMolecule(const char*,molecule**,std::string = "");
-  virtual void queryVector(const char*,Vector *,bool,std::string = "");
-  virtual void queryBox(const char*,Box*, std::string = "");
-  virtual void queryElement(const char*,std::vector<element *> *_target,std::string = "");
+  virtual void queryBoolean(const char *, std::string = "");
+  virtual void queryInt(const char *,std::string = "");
+  virtual void queryDouble(const char*,std::string = "");
+  virtual void queryString(const char*,std::string = "");
+  virtual void queryStrings(const char*,std::string = "");
+  virtual void queryAtom(const char*,std::string = "");
+  virtual void queryMolecule(const char*,std::string = "");
+  virtual void queryVector(const char*,bool,std::string = "");
+  virtual void queryBox(const char*, std::string = "");
+  virtual void queryElement(const char*,std::string = "");
 
   virtual bool display();
@@ -54,5 +54,5 @@
   class IntQTQuery : public Dialog::IntQuery {
     public:
-      IntQTQuery(std::string _title, int *_target,QBoxLayout *_parent,QTDialog *_dialog);
+      IntQTQuery(std::string _title,QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~IntQTQuery();
       virtual bool handle();
@@ -68,5 +68,5 @@
     class DoubleQTQuery : public Dialog::DoubleQuery {
     public:
-      DoubleQTQuery(std::string title, double *_target,QBoxLayout *_parent,QTDialog *_dialog);
+      DoubleQTQuery(std::string title,QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~DoubleQTQuery();
       virtual bool handle();
@@ -82,5 +82,5 @@
     class StringQTQuery : public Dialog::StringQuery {
     public:
-      StringQTQuery(std::string _title, std::string *_target, QBoxLayout *_parent,QTDialog *_dialog);
+      StringQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~StringQTQuery();
       virtual bool handle();
@@ -96,5 +96,5 @@
     class StringsQTQuery : public Dialog::StringsQuery {
     public:
-      StringsQTQuery(std::string _title, std::vector<std::string> *_target, QBoxLayout *_parent,QTDialog *_dialog);
+      StringsQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~StringsQTQuery();
       virtual bool handle();
@@ -110,5 +110,5 @@
     class MoleculeQTQuery : public Dialog::MoleculeQuery {
     public:
-      MoleculeQTQuery(std::string _title, molecule **_target, QBoxLayout *_parent,QTDialog *_dialog);
+      MoleculeQTQuery(std::string _title, QBoxLayout *_parent,QTDialog *_dialog);
       virtual ~MoleculeQTQuery();
       virtual bool handle();
@@ -124,5 +124,5 @@
     class VectorQTQuery : public Dialog::VectorQuery {
     public:
-      VectorQTQuery(std::string title,Vector *_target,bool _check,QBoxLayout *,QTDialog *);
+      VectorQTQuery(std::string title,bool _check,QBoxLayout *,QTDialog *);
       virtual ~VectorQTQuery();
       virtual bool handle();
@@ -141,5 +141,5 @@
     class ElementQTQuery : public Dialog::ElementQuery {
     public:
-      ElementQTQuery(std::string _title, std::vector<element *> *_target, QBoxLayout *_parent, QTDialog *_dialog);
+      ElementQTQuery(std::string _title, QBoxLayout *_parent, QTDialog *_dialog);
       virtual ~ElementQTQuery();
       virtual bool handle();
Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 7cd469035250605f6e00967cd82540daddab131e)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision 3731b4909c6d6ae4b595859d66058d1e878886f9)
@@ -321,5 +321,5 @@
   bool badInput=false;
   bool aborted = false;
-  element * tmp = NULL;
+  element * temp = NULL;
   do{
     badInput = false;
@@ -334,10 +334,10 @@
       }
       else{
-        tmp = World::getInstance().getPeriode()->FindElement(Z);
-        if(!tmp){
+        temp = World::getInstance().getPeriode()->FindElement(Z);
+        if(!temp){
           Log() << Verbose(0) << "No element with this atomic number!" << endl;
           badInput = true;
         } else {
-          elements.push_back(tmp);
+          tmp.push_back(temp);
         }
       }
@@ -358,10 +358,10 @@
       }
       else{
-        tmp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
-        if(!tmp){
+        temp = World::getInstance().getPeriode()->FindElement(shorthand.c_str());
+        if(!temp){
           Log() << Verbose(0) << "No element with this shorthand!" << endl;
           badInput = true;
         } else {
-          elements.push_back(tmp);
+          tmp.push_back(temp);
         }
       }