Index: tests/Calculations/testsuite-calculations-1_2-dimethoxyethane.at
===================================================================
--- tests/Calculations/testsuite-calculations-1_2-dimethoxyethane.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-1_2-dimethoxyethane.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-1_2-dimethylbenzene.at
===================================================================
--- tests/Calculations/testsuite-calculations-1_2-dimethylbenzene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-1_2-dimethylbenzene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-2-methylcyclohexanone.at
===================================================================
--- tests/Calculations/testsuite-calculations-2-methylcyclohexanone.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-2-methylcyclohexanone.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-N_N-dimethylacetamide.at
===================================================================
--- tests/Calculations/testsuite-calculations-N_N-dimethylacetamide.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-N_N-dimethylacetamide.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-anthracene.at
===================================================================
--- tests/Calculations/testsuite-calculations-anthracene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-anthracene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -44,5 +44,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-benzene.at
===================================================================
--- tests/Calculations/testsuite-calculations-benzene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-benzene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-cholesterol.at
===================================================================
--- tests/Calculations/testsuite-calculations-cholesterol.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-cholesterol.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-coronene.at
===================================================================
--- tests/Calculations/testsuite-calculations-coronene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-coronene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -44,5 +44,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-cycloheptane.at
===================================================================
--- tests/Calculations/testsuite-calculations-cycloheptane.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-cycloheptane.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-dimethyl_bromomalonate.at
===================================================================
--- tests/Calculations/testsuite-calculations-dimethyl_bromomalonate.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-dimethyl_bromomalonate.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-glucose.at
===================================================================
--- tests/Calculations/testsuite-calculations-glucose.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-glucose.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-heptan.at
===================================================================
--- tests/Calculations/testsuite-calculations-heptan.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-heptan.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-isoleucine.at
===================================================================
--- tests/Calculations/testsuite-calculations-isoleucine.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-isoleucine.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-naphthalene.at
===================================================================
--- tests/Calculations/testsuite-calculations-naphthalene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-naphthalene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -44,5 +44,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-neohexane.at
===================================================================
--- tests/Calculations/testsuite-calculations-neohexane.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-neohexane.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-phenanthrene.at
===================================================================
--- tests/Calculations/testsuite-calculations-phenanthrene.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-phenanthrene.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -44,5 +44,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-proline.at
===================================================================
--- tests/Calculations/testsuite-calculations-proline.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-proline.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-putrescine.at
===================================================================
--- tests/Calculations/testsuite-calculations-putrescine.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-putrescine.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP
Index: tests/Calculations/testsuite-calculations-tartaric_acid.at
===================================================================
--- tests/Calculations/testsuite-calculations-tartaric_acid.at	(revision fec597f5b80c0f86e5d9e73637b0ffff32750b57)
+++ tests/Calculations/testsuite-calculations-tartaric_acid.at	(revision 3834b60a172eb5fc5a8f0c36a9bc18ca164bb189)
@@ -45,5 +45,5 @@
 	 --fragment-resultfile ${FILENAME}_results.dat], 
 	 0, [stdout], [stderr])
-AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs($2 - energy) > 1e-5) exit(1)}'], 0)
+AT_CHECK([tail -n 1 ${FILENAME}_Energy.dat | awk -v energy=$ENERGY 'function abs(x){return ((x < 0.0) ? -x : x)} {if (abs(($2 - energy)/energy) > 1e-5) exit(1)}'], 0)
 
 AT_CLEANUP