Index: tests/Examples/Makefile.am
===================================================================
--- tests/Examples/Makefile.am	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
+++ tests/Examples/Makefile.am	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -0,0 +1,54 @@
+AUTOM4TE = $(SHELL) $(top_srcdir)/build-aux/missing --run autom4te
+
+if CONDJOBMARKET
+TESTSUITE = $(srcdir)/testsuite
+endif
+
+DISTCLEANFILES = atconfig
+
+TESTSCRIPTS =
+
+TESTSCRIPTS += \
+	$(srcdir)/testsuite-examples.at \
+	$(srcdir)/Simple/testsuite-examples-simple-h2o.at
+
+EXTRA_DIST = \
+	testsuite.at \
+	$(TESTSUITE) \
+	atlocal.in \
+	molecuilder.in \
+	package.m4 \
+	Simple \
+	$(TESTSCRIPTS)
+
+max_jobs = 4
+ 
+examples: atconfig atlocal $(TESTSUITE)
+	nrjobs=; \
+	for flag in $$MAKEFLAGS; do \
+		case $$flag in \
+		--* | =*=) ;; \
+		*j*) nrjobs="-j$(max_jobs)" ;; \
+		esac; \
+	done; \
+	$(SHELL) '$(TESTSUITE)' $$nrjobs AUTOTEST_PATH='$(abs_top_builddir)/src' $(TESTSUITEFLAGS)
+
+clean-local:
+	test ! -f '$(TESTSUITE)' || \
+	$(SHELL) '$(TESTSUITE)' --clean
+
+AUTOTEST = $(AUTOM4TE) --language=autotest
+$(TESTSUITE): $(srcdir)/testsuite.at package.m4 $(TESTSCRIPTS)
+	$(AUTOTEST) -I '$(srcdir)' -o $@.tmp $@.at
+	mv $@.tmp $@
+
+# The `:;' works around a Bash 3.2 bug when the output is not writeable.
+package.m4: $(top_srcdir)/configure.ac
+	:;{ \
+		echo '# Signature of the current package.' && \
+		echo 'm4_define([AT_PACKAGE_NAME],      [@PACKAGE_NAME@])' && \
+		echo 'm4_define([AT_PACKAGE_TARNAME],   [@PACKAGE_TARNAME@])' && \
+		echo 'm4_define([AT_PACKAGE_VERSION],   [@PACKAGE_VERSION@])' && \
+		echo 'm4_define([AT_PACKAGE_STRING],    [@PACKAGE_STRING@])' && \
+		echo 'm4_define([AT_PACKAGE_BUGREPORT], [@PACKAGE_BUGREPORT@])'; \
+	} >'package.m4'
Index: tests/Examples/Simple/pre/water.pdb
===================================================================
--- tests/Examples/Simple/pre/water.pdb	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
+++ tests/Examples/Simple/pre/water.pdb	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -0,0 +1,8 @@
+REMARK created by molecuilder on Tue Feb 26 16:16:10 2013, time step 0
+ATOM      1 O01 0non 01          0.000   0.000   0.000  0.00  0.00           O 0
+ATOM      2 H01 0non 01          0.720   0.000   0.558  0.00  0.00           H 0
+ATOM      3 H02 0non 01         -0.720   0.000   0.558  0.00  0.00           H 0
+CONECT    1    2    3                                                           
+CONECT    2    1                                                                
+CONECT    3    1                                                                
+END
Index: tests/Examples/Simple/testsuite-examples-simple-h2o.at
===================================================================
--- tests/Examples/Simple/testsuite-examples-simple-h2o.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
+++ tests/Examples/Simple/testsuite-examples-simple-h2o.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -0,0 +1,52 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### fragment the molecule and check the number of configs
+
+AT_SETUP([Examples - Simple h2o calculation])
+AT_KEYWORDS([fragmentation automation molecuilder server mpqc example])
+
+# check that ports are unique over all tests such that they may run in parallel
+WORKERPORT=2065
+CONTROLLERPORT=2066
+WORKERLISTENPORT=2067
+
+# start service in background
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+server_pid=$!
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
+
+# enlist a worker to work on jobs
+${AUTOTEST_PATH}/../ThirdParty/mpqc_open/src/bin/mpqc/mpqc -n "+v 5 ++signal 2 ++server 127.0.0.1:${WORKERPORT} ++hostname 127.0.0.1 ++listen $WORKERLISTENPORT" &
+worker_pid=$!
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# use molecuilder to add jobs, wait for their completion and obtain results
+AT_CHECK([../../molecuilder -i ${abs_top_srcdir}/tests/Examples/Simple/pre/water.pdb -v 3 --select-all-atoms --fragment-molecule BondFragment --order 1 --distance 2 --fragment-automation --server-address 127.0.0.1 --server-port $CONTROLLERPORT], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([fgrep "There are 1 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([fgrep "Energy: -75.6976" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([egrep 'Forces: .-4.64797e-16,1.53012e-17,0.0915748.; .-0.0764258,4.19204e-18,-0.0457874.; .0.0764258,-1.94932e-17,-0.0457874.' stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+
+# removeall to remove workers, then shutdown for server itself
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+
+# check that server is truely down
+AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([kill $server_pid $worker_pid], 1, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/Examples/testsuite-examples.at
===================================================================
--- tests/Examples/testsuite-examples.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
+++ tests/Examples/testsuite-examples.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -0,0 +1,21 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+AT_BANNER([MoleCuilder - Examples])
+
+# simple test with h2o
+m4_include([Simple/testsuite-examples-simple-h2o.at])
Index: tests/Examples/testsuite.at
===================================================================
--- tests/Examples/testsuite.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
+++ tests/Examples/testsuite.at	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -0,0 +1,30 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2008-2012 University of Bonn
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Process with autom4te to create an -*- Autotest -*- test suite.
+#
+# see regression/... subdirs wherein for each of the cases and each check (enumerated) is a pre and post dir. 
+# In pre initial files are placed, in post results can be found to be checked by diff in this testsuite.
+
+AT_INIT([Molecuilder Examples])
+AT_TESTED(diff grep egrep fgrep)
+
+# Use colored output with new-enough Autotest.
+m4_ifdef([AT_COLOR_TESTS], [AT_COLOR_TESTS])
+
+# JobMarket
+m4_include([testsuite-examples.at])
Index: tests/Makefile.am
===================================================================
--- tests/Makefile.am	(revision 889d80c0de7c69479d17ef2c785403680213d549)
+++ tests/Makefile.am	(revision 4464efb2e9bfaf89b69950e00696d947930cf682)
@@ -4,4 +4,5 @@
 	Calculations \
 	CodeChecks \
+	Examples \
 	GuiChecks \
 	regression \
@@ -19,2 +20,5 @@
 installextracheck:
 	cd Calculations && $(MAKE) installextracheck
+
+examples:
+	cd Examples && $(MAKE) examples